Imports System.Linq

Namespace QueryTests.Helpers
  Public Class TimeAnalyzer
	Private _times As List(Of Long)

	Public Sub New(ByVal times As List(Of Long))
	  _times = times
	  CalculateAllProperties()
	End Sub

	Public Property Cumulative As Long

	Public Property First As Long

	Public Property Last As Long

	Public Property Fastest As Long

	Public Property Slowest As Long

	Public Property AverageWithOutFastestOrSlowest As Long

	Private Sub CalculateAllProperties()
	  Cumulative = _times.Sum
	  First = _times.FirstOrDefault
	  Last = _times.LastOrDefault
	  Fastest = _times.Min
	  Slowest = _times.Max
	  AverageWithOutFastestOrSlowest = (Cumulative - Fastest - Slowest) / _times.Count
	End Sub
  End Class
End Namespace
