Imports Dapper.Domain
Imports System.Data.Common
Imports System.Data.Entity

Namespace DapperDesigners.Data.EF6
  Public Class DapperDesignerContext
	  Inherits DbContext

	Public Sub New()
		MyBase.New("DapperDesigns")
	End Sub

	Public Sub New(ByVal existingConnection As DbConnection, ByVal contextOwnsConnection As Boolean)
	End Sub

	Public Property Designers As DbSet(Of DapperDesigner)

	Public Property Clients As DbSet(Of Client)

	Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
	  modelBuilder.Entity(Of DapperDesigner)().HasOptional(Function(d) d.ContactInfo).WithRequired(Function(c) c.Designer)
	  MyBase.OnModelCreating(modelBuilder)
	End Sub
  End Class
End Namespace
