Imports System.Data.Entity.Migrations

Namespace DapperDesigners.Data.EF6.Migrations
	Partial Public Class init
		Inherits DbMigration

		Public Overrides Sub Up()
			CreateTable("dbo.Clients", Function(c) New With {Key .Id = c.Int(nullable:= False, identity:= True), Key .Name = c.String, Key .DefaultDappernessLevel = c.Int(nullable:= False)}).PrimaryKey(Function(t) t.Id)

			CreateTable("dbo.DapperDesigners", Function(c) New With {Key .Id = c.Int(nullable:= False, identity:= True), Key .LabelName = c.String, Key .Founder = c.String, Key .Dapperness = c.Int(nullable:= False)}).PrimaryKey(Function(t) t.Id)

			CreateTable("dbo.ContactInfoes", Function(c) New With {Key .Id = c.Int(nullable:= False), Key .Twitter = c.String}).PrimaryKey(Function(t) t.Id).ForeignKey("dbo.DapperDesigners", Function(t) t.Id).Index(Function(t) t.Id)

			CreateTable("dbo.Products", Function(c) New With {Key .Id = c.Int(nullable:= False, identity:= True), Key .Description = c.String, Key .DapperDesignerId = c.Int(nullable:= False)}).PrimaryKey(Function(t) t.Id).ForeignKey("dbo.DapperDesigners", Function(t) t.DapperDesignerId, cascadeDelete:= True).Index(Function(t) t.DapperDesignerId)

			CreateTable("dbo.DapperDesignerClients", Function(c) New With {Key .DapperDesigner_Id = c.Int(nullable:= False), Key .Client_Id = c.Int(nullable:= False)}).PrimaryKey(Function(t) New With {Key t.DapperDesigner_Id, Key t.Client_Id}).ForeignKey("dbo.DapperDesigners", Function(t) t.DapperDesigner_Id, cascadeDelete:= True).ForeignKey("dbo.Clients", Function(t) t.Client_Id, cascadeDelete:= True).Index(Function(t) t.DapperDesigner_Id).Index(Function(t) t.Client_Id)
		End Sub

		Public Overrides Sub Down()
			DropForeignKey("dbo.Products", "DapperDesignerId", "dbo.DapperDesigners")
			DropForeignKey("dbo.ContactInfoes", "Id", "dbo.DapperDesigners")
			DropForeignKey("dbo.DapperDesignerClients", "Client_Id", "dbo.Clients")
			DropForeignKey("dbo.DapperDesignerClients", "DapperDesigner_Id", "dbo.DapperDesigners")
			DropIndex("dbo.DapperDesignerClients", { "Client_Id" })
			DropIndex("dbo.DapperDesignerClients", { "DapperDesigner_Id" })
			DropIndex("dbo.Products", { "DapperDesignerId" })
			DropIndex("dbo.ContactInfoes", { "Id" })
			DropTable("dbo.DapperDesignerClients")
			DropTable("dbo.Products")
			DropTable("dbo.ContactInfoes")
			DropTable("dbo.DapperDesigners")
			DropTable("dbo.Clients")
		End Sub
	End Class
End Namespace
