Imports System.Data.SqlClient

Namespace QueryTests.Helpers
  Public Class Utils
	Public Shared Sub Output(ByVal times As List(Of Long), ByVal analyzer As TimeAnalyzer, ByVal source As String)
            times.ForEach(AddressOf Print)

            Console.WriteLine(source)
                              Console.WriteLine($"Total: {analyzer.Cumulative}")
                              Console.WriteLine($"Fastest: {analyzer.Fastest}")
                              Console.WriteLine($"Slowest: {analyzer.Slowest}")
                              Console.WriteLine($"Average without Fastest or Slowest: {analyzer.AverageWithOutFastestOrSlowest}")
        End Sub
        Shared Sub Print(ByVal s As Long)
            Console.WriteLine(s)
        End Sub

        Public Shared Function CreateOpenConnection() As SqlConnection
	  Dim connString As String = "Data Source=(localdb)\MSSQLLocalDB;Initial Catalog=DapperDesigns;Integrated Security=True;Connect Timeout=30;"
	  Dim conn = New SqlConnection(connString)
	  conn.Open()
	  Return conn
	End Function

	Public Shared Function CreateConnection() As SqlConnection
	  Dim connString As String = "Data Source=(localdb)\MSSQLLocalDB;Initial Catalog=DapperDesigns;Integrated Security=True;Connect Timeout=30;"
	  Dim conn = New SqlConnection(connString)
	  Return conn
	End Function
  End Class
End Namespace
